---------------------- SETUP REMOTE DISTRIBUTOR -----------------------
use master
GO
exec sp_adddistributor  @distributor = N'DBARCH20\SQLDB03', @password = N''
GO
-- Updating the agent profile defaults
sp_MSupdate_agenttype_default @profile_id = 1
GO
sp_MSupdate_agenttype_default @profile_id = 2
GO
sp_MSupdate_agenttype_default @profile_id = 4
GO
sp_MSupdate_agenttype_default @profile_id = 6
GO
sp_MSupdate_agenttype_default @profile_id = 11
GO
-- Adding the distribution database --
exec sp_adddistributiondb  @database = N'distribution', 
     @data_folder = N'C:\Program Files\Microsoft SQL Server\MSSQL\DATA', 
     @data_file = N'distribution.MDF', @data_file_size = 3, 
     @log_folder = N'C:\Program Files\Microsoft SQL Server\MSSQL\DATA', 
     @log_file = N'distribution.LDF', @log_file_size = 1, @min_distretention = 0, 
     @max_distretention = 72, @history_retention = 48, @security_mode = 0, 
     @login = N'sa', @password = null
GO


------------------------ SETUP PUBLISHER/PUSH SUBSCRIPTION --------------------
use master
GO
exec sp_adddistributor  @distributor = N'DBARCH20\SQLDB03', @password = N''
GO
-- Adding the registered subscriber --
exec sp_addsubscriber @subscriber = N'DBARCH30\SQLDB02', @type = 0, @login = N'sa', 
     @password = N'', @security_mode = 0, @frequency_type = 64, @frequency_interval = 1, 
     @frequency_relative_interval = 2, @frequency_recurrence_factor = 0, @frequency_subday = 8, 
     @frequency_subday_interval = 1, @active_start_date = 0, @active_end_date = 0, 
     @active_start_time_of_day = 0, @active_end_time_of_day = 235900, @description = N''
exec sp_changesubscriber_schedule @subscriber = N'DBARCH30\SQLDB02', @agent_type = 1, 
     @active_end_date = 0
GO
exec sp_replicationdboption @dbname = 'Northwind', @optname = 'publish', @value = 'true'
go
-- Add the publication for publisher DB --
use [Northwind]
GO
exec sp_addpublication @publication = N'Northwind2Northwind', @restricted = N'false', 
     @sync_method = N'native', @repl_freq = N'continuous', 
     @description = N'Transactional publication of Northwind database from Publisher 
     DBARCH10\SQLDB01.', @status = N'active', @allow_push = N'true', @allow_pull = N'true', 
     @allow_anonymous = N'false', @enabled_for_internet = N'false', @independent_agent = N'false', 
     @immediate_sync = N'false', @allow_sync_tran = N'false', @autogen_sync_procs = N'false', 
     @retention = 336, @allow_queued_tran = N'false', @snapshot_in_defaultfolder = N'true', 
     @compress_snapshot = N'false', @ftp_port = 21, @ftp_login = N'anonymous', 
     @allow_dts = N'false', @allow_subscription_copy = N'false', 
     @add_to_active_directory = N'false', @logreader_job_name = N'DBARCH10\SQLDB01-Northwind-1'

exec sp_addpublication_snapshot @publication = N'Northwind2Northwind',@frequency_type = 4, 
     @frequency_interval = 1, @frequency_relative_interval = 1, @frequency_recurrence_factor = 0, 
     @frequency_subday = 8, @frequency_subday_interval = 1, @active_start_date = 0, 
     @active_end_date = 0, @active_start_time_of_day = 0, @active_end_time_of_day = 235959, 
     @snapshot_job_name = N'DBARCH10\SQLDB01-Northwind-Northwind2Northwind-1'
GO

exec sp_grant_publication_access @publication = N'Northwind2Northwind', 
     @login = N'BUILTIN\Administrators'
GO
exec sp_grant_publication_access @publication = N'Northwind2Northwind', @login = N'sa'
GO

-- Adding the transactional articles --
exec sp_addarticle @publication = N'Northwind2Northwind', @article = N'Categories', 
     @source_owner = N'dbo', @source_object = N'Categories', @destination_table = N'Categories', 
     @type = N'logbased', @creation_script = null, @description = null, 
     @pre_creation_cmd = N'drop', @schema_option = 0x000000000000FFF3, 
     @status = 16, @vertical_partition = N'false', 
     @ins_cmd = N'CALL sp_MSins_Categories', @del_cmd = N'CALL sp_MSdel_Categories', 
     @upd_cmd = N'MCALL sp_MSupd_Categories', @filter = null, @sync_object = null, 
     @auto_identity_range = N'false'
GO

-- Adding the transactional subscription
exec sp_addsubscription @publication = N'Northwind2Northwind', @article = N'all', 
     @subscriber = N'DBARCH30\SQLDB02', @destination_db = N'Northwind', @sync_type = N'automatic', 
     @update_mode = N'read only', @offloadagent = 0, @dts_package_location = N'distributor'
GO


