-------------------------
-- Create a Test Table --
-------------------------
Use Northwind
go
CREATE TABLE [CustomersTest] (
	[CustomerID] [nchar] (5)  NOT NULL ,
	[CompanyName] [nvarchar] (40)  NOT NULL ,
	[ContactName] [nvarchar] (30)  NULL ,
	[ContactTitle] [nvarchar] (30)  NULL ,
	[Address] [nvarchar] (60)  NULL ,
	[City] [nvarchar] (15)  NULL ,
	[Region] [nvarchar] (15)  NULL ,
	[PostalCode] [nvarchar] (10)  NULL ,
	[Country] [nvarchar] (15)  NULL ,
	[Phone] [nvarchar] (24)  NULL ,
	[Fax] [nvarchar] (24)  NULL ,
	CONSTRAINT [PK_CustomersTest] PRIMARY KEY  CLUSTERED 
	(
		[CustomerID]
	)  ON [PRIMARY] 
) ON [PRIMARY]
GO
--------------------------------
-- Create a schema-bound view --
-- on this test table         --
--------------------------------
CREATE VIEW [dbo].[NODROPPK_Customers]
WITH SCHEMABINDING
AS
SELECT [CustomerID] FROM [dbo].[CustomersTest]
-- drop view [dbo].[NODROPPK_Customers]

-----------------------------------
-- Any Foreign Key Constraints?? --
-----------------------------------
EXEC sp_fkeys @pktable_name = N'Customers'
EXEC sp_fkeys @pktable_name = N'CustomersTest'
-------------------------------------
-- Any other object dependencies?? --
-------------------------------------
EXEC sp_depends N'Customers'
EXEC sp_depends N'CustomersTest'
----------------------------
-- Testing the protection --
----------------------------
DROP TABLE  [dbo].[CustomersTest]
Server: Msg 3729, Level 16, State 1, Line 1
Cannot DROP TABLE 'dbo.CustomersTest' because it is being referenced by object 'NODROP_Customers'.

CREATE VIEW [dbo].[NOALTERSCHEMA_Customers]
WITH SCHEMABINDING
AS
SELECT [CustomerID], [CompanyName], [ContactName], [ContactTitle], [Address], [City], [Region], [PostalCode], [Country], [Phone], [Fax] 
FROM [dbo].[CustomersTest]

ALTER TABLE [dbo].[CustomersTest] ALTER COLUMN [Fax] NVARCHAR(30) NOT NULL

Server: Msg 5074, Level 16, State 3, Line 1
The object 'NODROPSCHEMA_Customers' is dependent on column 'Fax'.
Server: Msg 4922, Level 16, State 1, Line 1

ALTER TABLE ALTER COLUMN Fax failed because one or more objects access this column.

ALTER TABLE [dbo].[CustomersTest] ADD [Cell] VARCHAR(24) NULL
The command(s) completed successfully.

ALTER TABLE [dbo].[CustomersTest] DROP COLUMN [Cell]
The command(s) completed successfully.

ALTER TABLE [dbo].[CustomersTest] DROP COLUMN [Fax]
Server: Msg 5074, Level 16, State 3, Line 1
The object 'NODROPSCHEMA_Customers' is dependent on column 'Fax'.
Server: Msg 4922, Level 16, State 1, Line 1
ALTER TABLE DROP COLUMN Fax failed because one or more objects access this column.
GO

---------------------
-- Managing Access --
---------------------
GRANT CREATE TABLE, CREATE VIEW to admintest
The command(s) completed successfully.

REVOKE ALL from admintest
The command(s) completed successfully.

EXEC sp_addsrvrolemember 'admintest', 'sysadmin'
-- 'admintest' added to role 'sysadmin'.

EXEC sp_addrole 'ManageMyDBObjects'
-- New role added.
GRANT CREATE TABLE to DonaldB
GRANT CREATE TABLE to ManageMyDBObjects
The command(s) completed successfully.

EXEC sp_addrolemember 'ManageMyDBObjects', 'admintest'
'admintest' added to role 'ManageMyDBObjects'.

EXEC sp_helprotect NULL, 'DonaldB'
Owner Object Grantee        Grantor ProtectType Action       Column 
----- ------ -------------- ------- ----------- ------------ ------ 
.     .      DonaldB        dbo     Grant       Create Table .


EXEC sp_helprotect NULL, NULL, NULL, 's'

Owner Object Grantee                            Grantor ProtectType Action       Column 
----- ------ ---------------------------------- ------- ----------- ------------ ------ 
.     .      DonaldB                            dbo     Grant       Create Table .
.     .      ManageMyDBObjects                  dbo     Grant       Create Table .
